#define FOSC 16000000UL
#define F_CPU 16000000UL

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <avr/pgmspace.h>
#include <compat/ina90.h>		// FOR _NOP(); _CLI(); AND _SEI();
#include <math.h>

#include "variables.h"
#include "timer-lib.h"
#include "lcd4bit-lib.h"
#include "adc-lib.h"
 

volatile unsigned int TIMER1_CAPTURE_EVENTS;

ISR(TIMER1_CAPT_vect)
{
	TIMER1_CAPTURE_EVENTS++;
}

volatile unsigned int TIMER0_OVERFLOW_EVENTS;

ISR(TIMER0_OVF_vect)
{	
	TIMER0_OVERFLOW_EVENTS++;					
}

volatile uint16_t TIMER1_COMPARE_EVENTS;
volatile uint16_t TIMER0_INPUT_CLOCK_EVENTS;

volatile unsigned long CALCULATED_FREQUENCY;

ISR(TIMER1_COMPA_vect)
{
	TIMER0_RESET();							// STOP T/C0	

	TIMER1_COMPARE_EVENTS++;				// UPDATE THIS EVENT'S COUNTER	
	TIMER0_INPUT_CLOCK_EVENTS 	= 0;		// CLEAR INPUT CLOCK COUNT	
	TIMER0_INPUT_CLOCK_EVENTS 	= TCNT0;	// STORE T/C0 REGISTER VALUE (# OF +EDGES)

	CALCULATED_FREQUENCY 		= (((long)TIMER0_OVERFLOW_EVENTS * 256) + (long)TIMER0_INPUT_CLOCK_EVENTS); 
	
	TIMER0_OVERFLOW_EVENTS 		= 0;		// CLEAR OVERFLOW COUNT
	TCNT0 						= 0;		// CLEAR T/C0 AND BE READY FOR NEXT CYCLE		
	TCNT1 						= 0;		// CLEAR T/C1 REGISTER AND BEGIN COUNTING CYCLE
	TIMER0_INITIALIZE();					// START T/C0: CLOCK ON +EDGE
}









//void delayme()
//{
//	int c = 1, d = 1;
// 
//	for ( c = 1 ; c <= 32767 ; c++ )
//		for ( d = 1 ; d <= 32767 ; d++ )
//		{
//		   _NOP();
//		}
//	
//	return;
//}



int main(void)
{	
	DDRC |= (0<<ADC0);								// SETUP ADC INPUT CHANNEL	

	DDRB &= ~(1<<PB0);								// DEFINE ICP1 AS INPUT
	
	LCD_INITIALIZE();								// INITIALIZE LCD			: SEE <lcd-lib.h> FOR DETAILS 
	ADC_INITIALIZE();								// INITIALIZE ADC			: SEE <adc-lib.h> FOR DETAILS 
	
	_SEI();											// ENABLE GLOBAL INTERRUPTS
	
	TIMER1_INITIALIZE();							// INITIALIZE T/C1			: SEE "timer-lib.h" FOR DETAILS
	TIMER0_INITIALIZE();							// INITIALIZE T/C0			: SEE "timer-lib.h" FOR DETAILS
	
	
	LCD_GOTO_XY(0,0);
	LCD_PRINT_STRING("TC1:");
	
	LCD_GOTO_XY(0,1);
	LCD_PRINT_STRING("CMP:");
	
	LCD_GOTO_XY(0,2);
	LCD_PRINT_STRING("OVF:");
	
	LCD_GOTO_XY(0,3);
	LCD_PRINT_STRING("CLK:");

	while(1) 
	{			
		LCD_GOTO_XY(7,0);
		LCD_SEND_INTEGER(TCNT1H);
		LCD_PRINT_STRING("|");
		LCD_SEND_INTEGER(TCNT1L);
		
		LCD_GOTO_XY(7,1);
		LCD_SEND_INTEGER(TIMER1_COMPARE_EVENTS);
		
		LCD_GOTO_XY(7,2);
		LCD_SEND_INTEGER(TIMER0_OVERFLOW_EVENTS);
		
		LCD_GOTO_XY(7,3);
		LCD_SEND_INTEGER(TIMER0_INPUT_CLOCK_EVENTS);	
		LCD_PRINT_STRING("|");
		//itoa(bufferA,CALCULATED_FREQUENCY,10);
		sprintf(bufferA,"%ld",CALCULATED_FREQUENCY);
		LCD_PRINT_STRING(bufferA);
		/*volatile uint8_t ethundredetusinde;
		volatile int temp1;
		volatile uint8_t titusinde;
		volatile int temp2;
		volatile uint8_t tusinde;
		volatile int temp3;
		volatile uint8_t hundrede;
		volatile int temp4;
		volatile uint8_t tiere;
		volatile int temp5;
		volatile uint8_t enere;
		
		ethundredetusinde 	= (int)CALCULATED_FREQUENCY/100000;
		temp1				= (int)CALCULATED_FREQUENCY%100000;
		titusinde			= (int)temp1/10000;
		temp2	 			= (int)CALCULATED_FREQUENCY%10000;
		tusinde				= (int)temp2/1000;
		temp3				= (int)CALCULATED_FREQUENCY%1000;
		hundrede			= (int)temp3/100;
		temp4				= (int)CALCULATED_FREQUENCY%100;
		tiere				= (int)temp4/10;
		temp5				= (int)CALCULATED_FREQUENCY%10;
		enere				= (int)temp5/1;
		
		itoa(ethundredetusinde,bufferA,10);
		LCD_SEND_BYTE(DATA,bufferA+48);
		itoa(titusinde,bufferA,10);
		LCD_SEND_BYTE(DATA,bufferA+48);
		itoa(tusinde,bufferA,10);
		LCD_SEND_BYTE(DATA,bufferA+48);
		itoa(hundrede,bufferA,10);
		LCD_SEND_BYTE(DATA,bufferA+48);
		itoa(tiere,bufferA,10);
		LCD_SEND_BYTE(DATA,bufferA+48);
		itoa(enere,bufferA,10);
		LCD_SEND_BYTE(DATA,bufferA+48);*/
	}
}
